Index: trunk/src/win32k/dev16/SymDB.c
===================================================================
--- trunk/src/win32k/dev16/SymDB.c	(revision 4529)
+++ trunk/src/win32k/dev16/SymDB.c	(revision 4530)
@@ -1,3 +1,3 @@
-/* $Id: SymDB.c,v 1.10 2000-10-26 00:30:32 bird Exp $
+/* $Id: SymDB.c,v 1.11 2000-10-26 03:00:58 bird Exp $
 *
 * Autogenerated kernel symbol database.
@@ -2457,4 +2457,280 @@
         }
     },
+#ifdef ALLKERNELS
+    { /* 14059H4.sym */
+        14059, KF_UNI | KF_W4 | KF_HALFSTRICT, 16,
+        {
+            {15, 0x00060840}, /* _ldrOpenPath */
+            {15, 0x00007a3c}, /* _ldrRead */
+            {15, 0x00060350}, /* _ldrOpen */
+            {15, 0x00061640}, /* _ldrClose */
+            {15, 0x00061725}, /* _LDRQAppType */
+            {15, 0x0005deb0}, /* _ldrEnum32bitRelRecs */
+            {15, 0x0006aa6e}, /* g_tkExecPgm */
+            {15, 0x000647bb}, /* _tkStartProcess */
+            {15, 0x0005c0a0}, /* _LDRClearSem */
+            {15, 0x0006b7c0}, /* _ldrASMpMTEFromHandle */
+            {15, 0x00065193}, /* _ldrFindModule */
+            {15, 0x0005c070}, /* _ldrValidateMteHandle */
+            {15, 0x0005c5f0}, /* _VMAllocMem */
+            {15, 0x0005cca0}, /* _VMFreeMem */
+            {15, 0x00047d7b}, /* _VMGetOwner */
+            {15, 0x00043c83}, /* _VMObjHandleInfo */
+            {15, 0x0008bfd3}, /* _VMMapDebugAlias */
+            {15, 0x0000ab54}, /* _KSEMRequestMutex */
+            {15, 0x0000ac2b}, /* _KSEMReleaseMutex */
+            {15, 0x0000ac56}, /* _KSEMQueryMutex */
+            {15, 0x0002e004}, /* _TKPidToPTDA */
+            {15, 0x000554e9}, /* _TKSuBuff */
+            {15, 0x00030a70}, /* _TKFuBuff */
+            {15, 0x00030850}, /* _TKFuBufLen */
+            {15, 0x00030b71}, /* _TKSuFuBuff */
+            {11, 0x0000e72c}, /* f_FuStrLenZ */
+            {11, 0x0000e6e2}, /* f_FuStrLen */
+            {11, 0x0000e825}, /* f_FuBuff */
+            {15, 0x00005056}, /* _SftFileSize */
+            {10, 0x0001f9a0}, /* _ldrpFileNameBuf */
+            {10, 0x0001e4b0}, /* _LdrSem */
+            {10, 0x0001dea4}, /* _pTCBCur */
+            {10, 0x0001dea0}, /* _pPTDACur */
+            {4 , 0x0000f8a0}, /* ptda_start */
+            {4 , 0x0000f9be}, /* ptda_environ */
+            {4 , 0x0000fec8}, /* ptda_ptdasem */
+            {4 , 0x0000ffa8}, /* ptda_handle */
+            {4 , 0x0000ffaa}, /* ptda_module */
+            {4 , 0x0000f9c0}, /* ptda_pBeginLIBPATH */
+            {15, 0x0005a010}, /* SecPathFromSFN */
+        }
+    },
+#endif
+#ifdef ALLKERNELS
+    { /* 14059HS.sym */
+        14059, KF_SMP | KF_HALFSTRICT, 17,
+        {
+            {16, 0x0006bd47}, /* _ldrOpenPath */
+            {16, 0x00008fc4}, /* _ldrRead */
+            {16, 0x0006b830}, /* _ldrOpen */
+            {16, 0x0006cbe0}, /* _ldrClose */
+            {16, 0x0006ccc5}, /* _LDRQAppType */
+            {16, 0x000690b0}, /* _ldrEnum32bitRelRecs */
+            {16, 0x00076eae}, /* g_tkExecPgm */
+            {16, 0x00070361}, /* _tkStartProcess */
+            {16, 0x00067040}, /* _LDRClearSem */
+            {16, 0x00077da0}, /* _ldrASMpMTEFromHandle */
+            {16, 0x00070da3}, /* _ldrFindModule */
+            {16, 0x00067010}, /* _ldrValidateMteHandle */
+            {16, 0x000675f0}, /* _VMAllocMem */
+            {16, 0x00067d50}, /* _VMFreeMem */
+            {16, 0x00052dab}, /* _VMGetOwner */
+            {16, 0x0004ea64}, /* _VMObjHandleInfo */
+            {16, 0x0009ae43}, /* _VMMapDebugAlias */
+            {16, 0x0000c8d8}, /* _KSEMRequestMutex */
+            {16, 0x0000c9af}, /* _KSEMReleaseMutex */
+            {16, 0x0000c9da}, /* _KSEMQueryMutex */
+            {16, 0x000365a4}, /* _TKPidToPTDA */
+            {16, 0x0005f777}, /* _TKSuBuff */
+            {16, 0x00039c20}, /* _TKFuBuff */
+            {16, 0x000399b1}, /* _TKFuBufLen */
+            {16, 0x00039d41}, /* _TKSuFuBuff */
+            {13, 0x00009eec}, /* f_FuStrLenZ */
+            {13, 0x00009e6c}, /* f_FuStrLen */
+            {13, 0x0000a096}, /* f_FuBuff */
+            {16, 0x00005e16}, /* _SftFileSize */
+            {11, 0x0001ee94}, /* _ldrpFileNameBuf */
+            {11, 0x0001d9b0}, /* _LdrSem */
+            {0 , 0x00000aa4}, /* _pTCBCur */
+            {0 , 0x00000aa0}, /* _pPTDACur */
+            {5 , 0x0000f88c}, /* ptda_start */
+            {5 , 0x0000f9aa}, /* ptda_environ */
+            {5 , 0x0000feb4}, /* ptda_ptdasem */
+            {5 , 0x0000ff94}, /* ptda_handle */
+            {5 , 0x0000ff96}, /* ptda_module */
+            {5 , 0x0000f9ac}, /* ptda_pBeginLIBPATH */
+            {16, 0x00064b90}, /* SecPathFromSFN */
+        }
+    },
+#endif
+#ifdef ALLKERNELS
+    { /* 14059HU.sym */
+        14059, KF_UNI | KF_HALFSTRICT, 16,
+        {
+            {15, 0x000608a0}, /* _ldrOpenPath */
+            {15, 0x00007a3c}, /* _ldrRead */
+            {15, 0x000603b0}, /* _ldrOpen */
+            {15, 0x000616a0}, /* _ldrClose */
+            {15, 0x00061785}, /* _LDRQAppType */
+            {15, 0x0005df10}, /* _ldrEnum32bitRelRecs */
+            {15, 0x0006aace}, /* g_tkExecPgm */
+            {15, 0x0006481b}, /* _tkStartProcess */
+            {15, 0x0005c100}, /* _LDRClearSem */
+            {15, 0x0006b820}, /* _ldrASMpMTEFromHandle */
+            {15, 0x000651f3}, /* _ldrFindModule */
+            {15, 0x0005c0d0}, /* _ldrValidateMteHandle */
+            {15, 0x0005c650}, /* _VMAllocMem */
+            {15, 0x0005cd00}, /* _VMFreeMem */
+            {15, 0x00047ddb}, /* _VMGetOwner */
+            {15, 0x00043ce3}, /* _VMObjHandleInfo */
+            {15, 0x0008c033}, /* _VMMapDebugAlias */
+            {15, 0x0000ab54}, /* _KSEMRequestMutex */
+            {15, 0x0000ac2b}, /* _KSEMReleaseMutex */
+            {15, 0x0000ac56}, /* _KSEMQueryMutex */
+            {15, 0x0002e064}, /* _TKPidToPTDA */
+            {15, 0x00055549}, /* _TKSuBuff */
+            {15, 0x00030ad0}, /* _TKFuBuff */
+            {15, 0x000308b0}, /* _TKFuBufLen */
+            {15, 0x00030bd1}, /* _TKSuFuBuff */
+            {11, 0x0000e72c}, /* f_FuStrLenZ */
+            {11, 0x0000e6e2}, /* f_FuStrLen */
+            {11, 0x0000e825}, /* f_FuBuff */
+            {15, 0x00005056}, /* _SftFileSize */
+            {10, 0x0001f9a0}, /* _ldrpFileNameBuf */
+            {10, 0x0001e4b0}, /* _LdrSem */
+            {10, 0x0001dea4}, /* _pTCBCur */
+            {10, 0x0001dea0}, /* _pPTDACur */
+            {4 , 0x0000f8a0}, /* ptda_start */
+            {4 , 0x0000f9be}, /* ptda_environ */
+            {4 , 0x0000fec8}, /* ptda_ptdasem */
+            {4 , 0x0000ffa8}, /* ptda_handle */
+            {4 , 0x0000ffaa}, /* ptda_module */
+            {4 , 0x0000f9c0}, /* ptda_pBeginLIBPATH */
+            {15, 0x0005a070}, /* SecPathFromSFN */
+        }
+    },
+#endif
+    { /* 14059R4.sym */
+        14059, KF_UNI | KF_W4, 14,
+        {
+            {13, 0x0005ed10}, /* _ldrOpenPath */
+            {13, 0x000070cc}, /* _ldrRead */
+            {13, 0x0005e820}, /* _ldrOpen */
+            {13, 0x0005fb10}, /* _ldrClose */
+            {13, 0x0005fbf5}, /* _LDRQAppType */
+            {13, 0x0005c380}, /* _ldrEnum32bitRelRecs */
+            {13, 0x00068f0e}, /* g_tkExecPgm */
+            {13, 0x00062c7b}, /* _tkStartProcess */
+            {13, 0x0005a570}, /* _LDRClearSem */
+            {13, 0x00069c60}, /* _ldrASMpMTEFromHandle */
+            {13, 0x00063633}, /* _ldrFindModule */
+            {13, 0x0005a540}, /* _ldrValidateMteHandle */
+            {13, 0x0005aac0}, /* _VMAllocMem */
+            {13, 0x0005b170}, /* _VMFreeMem */
+            {13, 0x000462db}, /* _VMGetOwner */
+            {13, 0x000421e3}, /* _VMObjHandleInfo */
+            {13, 0x0008a393}, /* _VMMapDebugAlias */
+            {13, 0x0000a138}, /* _KSEMRequestMutex */
+            {13, 0x0000a1cb}, /* _KSEMReleaseMutex */
+            {13, 0x0000a1f6}, /* _KSEMQueryMutex */
+            {13, 0x0002c7d4}, /* _TKPidToPTDA */
+            {13, 0x000539b5}, /* _TKSuBuff */
+            {13, 0x0002f100}, /* _TKFuBuff */
+            {13, 0x0002eee0}, /* _TKFuBufLen */
+            {13, 0x0002f201}, /* _TKSuFuBuff */
+            {9 , 0x0000e72c}, /* f_FuStrLenZ */
+            {9 , 0x0000e6e2}, /* f_FuStrLen */
+            {9 , 0x0000e825}, /* f_FuBuff */
+            {13, 0x00004fd6}, /* _SftFileSize */
+            {8 , 0x0000f364}, /* _ldrpFileNameBuf */
+            {8 , 0x0000de94}, /* _LdrSem */
+            {8 , 0x0000d884}, /* _pTCBCur */
+            {8 , 0x0000d880}, /* _pPTDACur */
+            {2 , 0x0000f8a0}, /* ptda_start */
+            {2 , 0x0000f9be}, /* ptda_environ */
+            {2 , 0x0000fec8}, /* ptda_ptdasem */
+            {2 , 0x0000ffa8}, /* ptda_handle */
+            {2 , 0x0000ffaa}, /* ptda_module */
+            {2 , 0x0000f9c0}, /* ptda_pBeginLIBPATH */
+            {13, 0x000584e0}, /* SecPathFromSFN */
+        }
+    },
+    { /* 14059RS.sym */
+        14059, KF_SMP, 15,
+        {
+            {14, 0x00069857}, /* _ldrOpenPath */
+            {14, 0x0000836c}, /* _ldrRead */
+            {14, 0x00069340}, /* _ldrOpen */
+            {14, 0x0006a6f0}, /* _ldrClose */
+            {14, 0x0006a7d5}, /* _LDRQAppType */
+            {14, 0x00066bc0}, /* _ldrEnum32bitRelRecs */
+            {14, 0x0007499e}, /* g_tkExecPgm */
+            {14, 0x0006de61}, /* _tkStartProcess */
+            {14, 0x00064b50}, /* _LDRClearSem */
+            {14, 0x00075890}, /* _ldrASMpMTEFromHandle */
+            {14, 0x0006e893}, /* _ldrFindModule */
+            {14, 0x00064b20}, /* _ldrValidateMteHandle */
+            {14, 0x00065100}, /* _VMAllocMem */
+            {14, 0x00065860}, /* _VMFreeMem */
+            {14, 0x0005095b}, /* _VMGetOwner */
+            {14, 0x0004c614}, /* _VMObjHandleInfo */
+            {14, 0x000987d3}, /* _VMMapDebugAlias */
+            {14, 0x0000bb74}, /* _KSEMRequestMutex */
+            {14, 0x0000bc07}, /* _KSEMReleaseMutex */
+            {14, 0x0000bc32}, /* _KSEMQueryMutex */
+            {14, 0x000343c4}, /* _TKPidToPTDA */
+            {14, 0x0005d293}, /* _TKSuBuff */
+            {14, 0x00037900}, /* _TKFuBuff */
+            {14, 0x00037691}, /* _TKFuBufLen */
+            {14, 0x00037a21}, /* _TKSuFuBuff */
+            {11, 0x00009e0c}, /* f_FuStrLenZ */
+            {11, 0x00009d8c}, /* f_FuStrLen */
+            {11, 0x00009fb6}, /* f_FuBuff */
+            {14, 0x00005d66}, /* _SftFileSize */
+            {9 , 0x0000e844}, /* _ldrpFileNameBuf */
+            {9 , 0x0000d380}, /* _LdrSem */
+            {0 , 0x00000aa4}, /* _pTCBCur */
+            {0 , 0x00000aa0}, /* _pPTDACur */
+            {3 , 0x0000f88c}, /* ptda_start */
+            {3 , 0x0000f9aa}, /* ptda_environ */
+            {3 , 0x0000feb4}, /* ptda_ptdasem */
+            {3 , 0x0000ff94}, /* ptda_handle */
+            {3 , 0x0000ff96}, /* ptda_module */
+            {3 , 0x0000f9ac}, /* ptda_pBeginLIBPATH */
+            {14, 0x000626a0}, /* SecPathFromSFN */
+        }
+    },
+    { /* 14059RU.sym */
+        14059, KF_UNI, 14,
+        {
+            {13, 0x0005ed80}, /* _ldrOpenPath */
+            {13, 0x000070cc}, /* _ldrRead */
+            {13, 0x0005e890}, /* _ldrOpen */
+            {13, 0x0005fb80}, /* _ldrClose */
+            {13, 0x0005fc65}, /* _LDRQAppType */
+            {13, 0x0005c3f0}, /* _ldrEnum32bitRelRecs */
+            {13, 0x00068f7e}, /* g_tkExecPgm */
+            {13, 0x00062ceb}, /* _tkStartProcess */
+            {13, 0x0005a5e0}, /* _LDRClearSem */
+            {13, 0x00069cd0}, /* _ldrASMpMTEFromHandle */
+            {13, 0x000636a3}, /* _ldrFindModule */
+            {13, 0x0005a5b0}, /* _ldrValidateMteHandle */
+            {13, 0x0005ab30}, /* _VMAllocMem */
+            {13, 0x0005b1e0}, /* _VMFreeMem */
+            {13, 0x0004634b}, /* _VMGetOwner */
+            {13, 0x00042253}, /* _VMObjHandleInfo */
+            {13, 0x0008a403}, /* _VMMapDebugAlias */
+            {13, 0x0000a138}, /* _KSEMRequestMutex */
+            {13, 0x0000a1cb}, /* _KSEMReleaseMutex */
+            {13, 0x0000a1f6}, /* _KSEMQueryMutex */
+            {13, 0x0002c844}, /* _TKPidToPTDA */
+            {13, 0x00053a25}, /* _TKSuBuff */
+            {13, 0x0002f170}, /* _TKFuBuff */
+            {13, 0x0002ef50}, /* _TKFuBufLen */
+            {13, 0x0002f271}, /* _TKSuFuBuff */
+            {9 , 0x0000e72c}, /* f_FuStrLenZ */
+            {9 , 0x0000e6e2}, /* f_FuStrLen */
+            {9 , 0x0000e825}, /* f_FuBuff */
+            {13, 0x00004fd6}, /* _SftFileSize */
+            {8 , 0x0000f364}, /* _ldrpFileNameBuf */
+            {8 , 0x0000de94}, /* _LdrSem */
+            {8 , 0x0000d884}, /* _pTCBCur */
+            {8 , 0x0000d880}, /* _pPTDACur */
+            {2 , 0x0000f8a0}, /* ptda_start */
+            {2 , 0x0000f9be}, /* ptda_environ */
+            {2 , 0x0000fec8}, /* ptda_ptdasem */
+            {2 , 0x0000ffa8}, /* ptda_handle */
+            {2 , 0x0000ffaa}, /* ptda_module */
+            {2 , 0x0000f9c0}, /* ptda_pBeginLIBPATH */
+            {13, 0x00058550}, /* SecPathFromSFN */
+        }
+    },
     { /* 8255RS.sym */
         8255, KF_SMP, 15,