Index: trunk/src/opengl/glide/cvg/glide/makefile
===================================================================
--- trunk/src/opengl/glide/cvg/glide/makefile	(revision 4719)
+++ trunk/src/opengl/glide/cvg/glide/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 2000-11-19 08:58:11 bird Exp $
+# $Id: makefile,v 1.6 2000-12-03 00:26:12 bird Exp $
 
 #
@@ -7,11 +7,4 @@
 #
 
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 #
@@ -25,6 +18,6 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
-!include ..\3dfx.mak
+!include ../../../../../makefile.inc
+!include ../3dfx.mak
 
 
@@ -79,5 +72,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/cvg/init/makefile
===================================================================
--- trunk/src/opengl/glide/cvg/init/makefile	(revision 4719)
+++ trunk/src/opengl/glide/cvg/init/makefile	(revision 4720)
@@ -1,3 +1,4 @@
-# $Id: makefile,v 1.3 2000-11-19 08:58:11 bird Exp $
+# $Id: makefile,v 1.4 2000-12-03 00:26:12 bird Exp $
+
 #
 # Odin32 API
@@ -5,13 +6,4 @@
 #       cvg\Init makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB = ..\..\..\..\..\lib
-PDWIN32_BIN = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS = ..\..\..\..\..\tools\bin
 
 
@@ -26,5 +18,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../../makefile.inc
 !include ..\3dfx.mak
 
@@ -61,5 +53,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/cvg/makefile
===================================================================
--- trunk/src/opengl/glide/cvg/makefile	(revision 4719)
+++ trunk/src/opengl/glide/cvg/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.11 2000-11-19 08:58:10 bird Exp $
+# $Id: makefile,v 1.12 2000-12-03 00:26:11 bird Exp $
 
 #
@@ -6,13 +6,4 @@
 #       Glide\cvg makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\$(OBJDIR)\Glide\Voodoo2
-PDWIN32_TOOLS   = ..\..\..\..\tools\bin
 
 
@@ -26,5 +17,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../makefile.inc
 
 
@@ -54,6 +45,6 @@
 init\$(OBJDIR)/init.lib \
 glide\$(OBJDIR)/glide.lib \
-$(PDWIN32_LIB)/kernel32.lib \
-$(PDWIN32_LIB)/$(ODINCRT).lib \
+$(ODIN32_LIB)/kernel32.lib \
+$(ODIN32_LIB)/$(ODINCRT).lib \
 os2386.lib \
 $(RTLLIB_O)
@@ -69,4 +60,4 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
Index: trunk/src/opengl/glide/cvg/texus/makefile
===================================================================
--- trunk/src/opengl/glide/cvg/texus/makefile	(revision 4719)
+++ trunk/src/opengl/glide/cvg/texus/makefile	(revision 4720)
@@ -1,16 +1,9 @@
-# $Id: makefile,v 1.3 2000-11-19 08:58:11 bird Exp $
+# $Id: makefile,v 1.4 2000-12-03 00:26:12 bird Exp $
+
 #
-# PD-Win32 API
+# Odin32 API
 #
 #       Glide makefile
 #
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 
@@ -25,6 +18,6 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
-!include ..\3dfx.mak
+!include ../../../../../makefile.inc
+!include ../3dfx.mak
 
 
@@ -69,5 +62,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/makefile
===================================================================
--- trunk/src/opengl/glide/makefile	(revision 4719)
+++ trunk/src/opengl/glide/makefile	(revision 4720)
@@ -1,3 +1,4 @@
-# $Id: makefile,v 1.7 2000-11-19 08:58:10 bird Exp $
+# $Id: makefile,v 1.8 2000-12-03 00:26:11 bird Exp $
+
 #
 # Odin32 API
@@ -8,14 +9,7 @@
 
 #
-# Directories
-#
-PDWIN32_INCLUDE = ..\..\..\include
-PDWIN32_TOOLS   = ..\..\..\tools\bin
-
-
-#
 # Common tools macros. (MAKE_CMD)
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.tools
+!include ../../../makefile.inc
 
 
@@ -25,9 +19,5 @@
 
 # All, Lib, Clean and Dep rules.
-dep clean lib all:
-    cd cvg
-    $(MAKE_CMD) $@
-    cd ..\sst1
-    $(MAKE_CMD) $@
-    cd ..
+$(COMMONRULES):
+    $(DODIRS) "cvg sst1" $(MAKE_CMD) $@
 
Index: trunk/src/opengl/glide/sst1/glide/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/glide/makefile	(revision 4719)
+++ trunk/src/opengl/glide/sst1/glide/makefile	(revision 4720)
@@ -1,3 +1,4 @@
-# $Id: makefile,v 1.3 2000-11-19 08:58:11 bird Exp $
+# $Id: makefile,v 1.4 2000-12-03 00:26:13 bird Exp $
+
 #
 # Odin32 API
@@ -5,13 +6,4 @@
 #       sst1/Glide makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 
@@ -26,5 +18,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../../makefile.inc
 !include ..\3dfx.mak
 
@@ -78,5 +70,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/sst1/init/initvg/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/init/initvg/makefile	(revision 4719)
+++ trunk/src/opengl/glide/sst1/init/initvg/makefile	(revision 4720)
@@ -1,17 +1,9 @@
-# $Id: makefile,v 1.3 2000-11-19 08:58:12 bird Exp $
+# $Id: makefile,v 1.4 2000-12-03 00:26:13 bird Exp $
+
 #
-# PD-Win32 API
+# Odin32 API
 #
 #       sst1/init/inivg makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\..\tools\bin
 
 
@@ -26,5 +18,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../../../makefile.inc
 !include ..\..\3dfx.mak
 
@@ -61,5 +53,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/sst1/init/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/init/makefile	(revision 4719)
+++ trunk/src/opengl/glide/sst1/init/makefile	(revision 4720)
@@ -1,3 +1,4 @@
-# $Id: makefile,v 1.4 2000-11-19 08:58:11 bird Exp $
+# $Id: makefile,v 1.5 2000-12-03 00:26:13 bird Exp $
+
 #
 # Odin32 API
@@ -5,13 +6,4 @@
 #       sst1\Init makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 
@@ -26,5 +18,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../../makefile.inc
 !include ..\3dfx.mak
 
@@ -63,5 +55,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/sst1/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/makefile	(revision 4719)
+++ trunk/src/opengl/glide/sst1/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.8 2000-11-19 08:58:11 bird Exp $
+# $Id: makefile,v 1.9 2000-12-03 00:26:12 bird Exp $
 
 #
@@ -6,13 +6,4 @@
 #       sst1\Glide makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\$(OBJDIR)\Glide\Voodoo1
-PDWIN32_TOOLS   = ..\..\..\..\tools\bin
 
 
@@ -26,5 +17,11 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../makefile.inc
+
+
+#
+# Overrides.
+#
+ODIN32_BIN = $(ODIN32_BIN__)\Glide\Voodoo1
 
 
@@ -55,6 +52,6 @@
 init/initvg/$(OBJDIR)/initvg.lib \
 glide/$(OBJDIR)/glide.lib \
-$(PDWIN32_LIB)/kernel32.lib \
-$(PDWIN32_LIB)/$(ODINCRT).lib \
+$(ODIN32_LIB)/kernel32.lib \
+$(ODIN32_LIB)/$(ODINCRT).lib \
 OS2386.LIB \
 $(RTLLIB_O)
@@ -70,4 +67,4 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
Index: trunk/src/opengl/glide/sst1/texus/makefile
===================================================================
--- trunk/src/opengl/glide/sst1/texus/makefile	(revision 4719)
+++ trunk/src/opengl/glide/sst1/texus/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.3 2000-11-19 08:58:12 bird Exp $
+# $Id: makefile,v 1.4 2000-12-03 00:26:13 bird Exp $
 
 #
@@ -6,13 +6,4 @@
 #       sst1/Texus makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 
@@ -27,6 +18,6 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
-!include ..\3dfx.mak
+!include ../../../../../makefile.inc
+!include ../3dfx.mak
 
 
@@ -71,5 +62,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glide/swlibs/pcilib/makefile
===================================================================
--- trunk/src/opengl/glide/swlibs/pcilib/makefile	(revision 4719)
+++ trunk/src/opengl/glide/swlibs/pcilib/makefile	(revision 4720)
@@ -1,3 +1,4 @@
-# $Id: makefile,v 1.4 2000-11-19 08:58:12 bird Exp $
+# $Id: makefile,v 1.5 2000-12-03 00:26:14 bird Exp $
+
 #
 # Odin32 API
@@ -5,13 +6,4 @@
 #       swlibs\pcilib makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 
@@ -26,5 +18,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../../makefile.inc
 !include ..\..\sst1\3dfx.mak
 
@@ -55,5 +47,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/glu/makefile
===================================================================
--- trunk/src/opengl/glu/makefile	(revision 4719)
+++ trunk/src/opengl/glu/makefile	(revision 4720)
@@ -1,23 +1,15 @@
-# $Id: makefile,v 1.14 2000-11-19 08:58:13 bird Exp $
+# $Id: makefile,v 1.15 2000-12-03 00:26:14 bird Exp $
 
 #
 # Odin32 API
 #
-# Top-level makefile for glu32
+#       Top-level makefile for glu32
 #
 
 
 #
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\include
-PDWIN32_LIB     = ..\..\..\lib
-PDWIN32_BIN     = ..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\tools\bin
-
-#
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../makefile.inc
 
 
@@ -54,7 +46,7 @@
 tess\$(OBJDIR)\tess.lib \
 util\$(OBJDIR)\util.lib \
-$(PDWIN32_LIB)/$(ODINCRT).lib \
-$(PDWIN32_LIB)\kernel32.lib \
-$(PDWIN32_LIB)\opengl32.lib \
+$(ODIN32_LIB)/$(ODINCRT).lib \
+$(ODIN32_LIB)\kernel32.lib \
+$(ODIN32_LIB)\opengl32.lib \
 $(RTLLIB_O) \
 os2386.lib
@@ -70,4 +62,4 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
Index: trunk/src/opengl/glu/nurbs/makefile
===================================================================
--- trunk/src/opengl/glu/nurbs/makefile	(revision 4719)
+++ trunk/src/opengl/glu/nurbs/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.7 2000-11-19 08:58:13 bird Exp $
+# $Id: makefile,v 1.8 2000-12-03 00:26:15 bird Exp $
 
 #
@@ -9,16 +9,7 @@
 
 #
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\tools\bin
-
-
-#
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../makefile.inc
 
 
Index: trunk/src/opengl/glu/nurbs/nurbtess/makefile
===================================================================
--- trunk/src/opengl/glu/nurbs/nurbtess/makefile	(revision 4719)
+++ trunk/src/opengl/glu/nurbs/nurbtess/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.5 2000-11-19 08:58:14 bird Exp $
+# $Id: makefile,v 1.6 2000-12-03 00:25:51 bird Exp $
 
 #
@@ -6,13 +6,4 @@
 #       glu/nurbs/nurbtess makefile
 #
-
-
-#
-# Directory macros.
-#
-PDWIN32_INCLUDE = ..\..\..\..\..\include
-PDWIN32_LIB     = ..\..\..\..\..\lib
-PDWIN32_BIN     = ..\..\..\..\..\$(OBJDIR)
-PDWIN32_TOOLS   = ..\..\..\..\..\tools\bin
 
 
@@ -27,5 +18,5 @@
 # Compiler, tools, and interference rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.mk
+!include ../../../../../makefile.inc
 
 
@@ -71,5 +62,5 @@
 # Includes the common rules.
 #
-!include $(PDWIN32_INCLUDE)/pdwin32.post
+!include $(ODIN32_POST_INC)
 
 
Index: trunk/src/opengl/makefile
===================================================================
--- trunk/src/opengl/makefile	(revision 4719)
+++ trunk/src/opengl/makefile	(revision 4720)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.18 2000-11-19 08:58:10 bird Exp $
+# $Id: makefile,v 1.19 2000-12-03 00:26:11 bird Exp $
 #
 # Odin32 API
@@ -8,5 +8,5 @@
 
 # Common tools macros. (MAKE_CMD)
-!include ../../include/pdwin32.mk
+!include ../../makefile.inc
 
 
@@ -23,6 +23,7 @@
 .\mesa\3dfx
 
-# All, Lib, Clean and Dep rules.
-clean dep all lib:
+# All the common rules like all, lib, clean and dep.
+$(COMMONRULES):
     $(DODIRS) "$(SUBDIRS)" $(MAKE_CMD) $@
 
+