Index: trunk/src/user32/HOOK.CPP
===================================================================
--- trunk/src/user32/HOOK.CPP	(revision 4758)
+++ trunk/src/user32/HOOK.CPP	(revision 4759)
@@ -1,3 +1,3 @@
-/* $Id: HOOK.CPP,v 1.16 2000-11-21 11:36:07 sandervl Exp $ */
+/* $Id: HOOK.CPP,v 1.17 2000-12-06 15:39:42 phaller Exp $ */
 
 /*
@@ -24,4 +24,13 @@
  * handle in the low 16 bits and of a HOOK_MAGIC value in the high 16 bits.
  */
+
+/*****************************************************************************
+ * Includes                                                                  *
+ *****************************************************************************/
+
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2sel.h>
+
 
 #include <os2win.h>
@@ -39,9 +48,15 @@
 #include "dbglocal.h"
 
+ODINDEBUGCHANNEL(USER32-HOOK)
 DEFAULT_DEBUG_CHANNEL(hook)
 
 #include "pshpack1.h"
 
-  /* Hook data (pointed to by a HHOOK) */
+
+/*****************************************************************************
+ * Definitions, structures, and variables                                    *
+ *****************************************************************************/
+
+/* Hook data (pointed to by a HHOOK) */
 typedef struct
 {
@@ -589,5 +604,7 @@
  *           SetWindowsHook32A   (USER32.525)
  */
-HHOOK WINAPI SetWindowsHookA( INT id, HOOKPROC proc )
+ODINFUNCTION2(HHOOK, SetWindowsHookA,
+              INT, id, 
+              HOOKPROC, proc )
 {
     return SetWindowsHookExA( id, proc, 0, GetCurrentThreadId() );
@@ -597,5 +614,7 @@
  *           SetWindowsHook32W   (USER32.528)
  */
-HHOOK WINAPI SetWindowsHookW( INT id, HOOKPROC proc )
+ODINFUNCTION2(HHOOK, SetWindowsHookW,
+              INT, id, 
+              HOOKPROC, proc)
 {
     return SetWindowsHookExW( id, proc, 0, GetCurrentThreadId() );
@@ -605,6 +624,9 @@
  *           SetWindowsHookEx32A   (USER32.526)
  */
-HHOOK WINAPI SetWindowsHookExA( INT id, HOOKPROC proc, HINSTANCE hInst,
-                                  DWORD dwThreadId )
+ODINFUNCTION4(HHOOK, SetWindowsHookExA,
+              INT, id, 
+              HOOKPROC, proc, 
+              HINSTANCE, hInst,
+              DWORD, dwThreadId )
 {
     return HOOK_SetHook( id, proc, HOOK_WIN32A, hInst, dwThreadId );
@@ -614,6 +636,9 @@
  *           SetWindowsHookEx32W   (USER32.527)
  */
-HHOOK WINAPI SetWindowsHookExW( INT id, HOOKPROC proc, HINSTANCE hInst,
-                                  DWORD dwThreadId )
+ODINFUNCTION4(HHOOK, SetWindowsHookExW,
+              INT, id, 
+              HOOKPROC, proc, 
+              HINSTANCE, hInst,
+              DWORD, dwThreadId )
 {
     return HOOK_SetHook( id, proc, HOOK_WIN32W, hInst, dwThreadId );
@@ -623,5 +648,7 @@
  *           UnhookWindowsHook32   (USER32.557)
  */
-BOOL WINAPI UnhookWindowsHook( INT id, HOOKPROC proc )
+ODINFUNCTION2(BOOL, UnhookWindowsHook,
+              INT, id, 
+              HOOKPROC, proc )
 {
     HANDLE hook = HOOK_GetHook( id, GetCurrentThreadId() );
@@ -643,5 +670,6 @@
  *           UnhookWindowHookEx32   (USER32.558)
  */
-BOOL WINAPI UnhookWindowsHookEx( HHOOK hhook )
+ODINFUNCTION1(BOOL, UnhookWindowsHookEx,
+              HHOOK, hhook )
 {
     if (CHECK_MAGIC(hhook) == FALSE) {
@@ -658,6 +686,9 @@
  * There aren't ANSI and UNICODE versions of this.
  */
-LRESULT WINAPI CallNextHookEx( HHOOK hhook, INT code, WPARAM wParam,
-                                 LPARAM lParam )
+ODINFUNCTION4(LRESULT, CallNextHookEx, 
+              HHOOK, hhook, 
+              INT, code, 
+              WPARAM, wParam,
+              LPARAM, lParam )
 {
     HANDLE next;
@@ -685,5 +716,7 @@
  * version, plus USER (the 16bit one) has a CallMsgFilter32 function.
  */
-BOOL WINAPI CallMsgFilterA( LPMSG msg, INT code )
+ODINFUNCTION2(BOOL, CallMsgFilterA,
+              LPMSG, msg, 
+              INT, code )
 {
 #if 0 //CB: not a Win32 API and unimplemented
@@ -699,5 +732,7 @@
  *           CallMsgFilter32W   (USER32.16)
  */
-BOOL WINAPI CallMsgFilterW( LPMSG msg, INT code )
+ODINFUNCTION2(BOOL, CallMsgFilterW,
+              LPMSG, msg, 
+              INT, code )
 {
 #if 0 //CB: not a Win32 API and unimplemented